#include <:Mac #includes:asm.h>
#include <:Mac #includes:Color.h>

#include "Commando:Programming:LightspeedC:Vision Lab:shared.h"

int main(AppDataPtr)
register SharePtr AppDataPtr;
{
	unsigned long chunkSize;
	register int x, y, value;
	int Xstr, Ystr, Xend, Yend;
	/*	set up some local variables */
	Xstr = AppDataPtr->selRect.left;
	Ystr = AppDataPtr->selRect.top;
	Xend = AppDataPtr->selRect.right;
	Yend = AppDataPtr->selRect.bottom;
	/*	check image size */
	if ((Xend-Xstr <= 0) || (Yend-Ystr <= 0)) {
		/*	return if there is no image to work with */
		return(noErr);
	}
	/*	set up the bar graph so we know about how long our experimental PROC
		needs.  In this case we will use the number of pixels processed.
	*/
	tSizeM  = Xend-Xstr;
	tSizeM *= Yend-Ystr;
	pSizeM  = 0;
	chunkSize = tSizeM / 16;
	setupBarGraphM("\pThreshold processing");
	/*	finally fill the bits by processing the pixmap */
	for (x = Xstr; x<Xend; x++) {
		for (y = Ystr; y<Yend; y++) {
			/*	get the value of the pixel at x, y in the PixMap */
			value = getAPixelM(x, y, AppDataPtr->pixMapPtr);
			/*	turn the value into a gray level from 0 (black) to 255 (white) */
			value = *(AppDataPtr->grayMapPtr+value);
			if (value < 128) {
				/*	set the pixel at x, y in the BitMap if the gray level
					is "dark".
				*/
				setAPixelM(x, y, AppDataPtr->bitMapPtr, 1);
			}
			else {
				/*	clear the pixel at x, y in the BitMap if the gray level
					is "light".
				*/
				setAPixelM(x, y, AppDataPtr->bitMapPtr, 0);
			}
			/*	increase the processed bytes counter */
			++pSizeM;
			/*	update the bar graph a total of 16 times */
			if (pSizeM > chunkSize) {
				chunkSize += tSizeM / 16;
				updateBarGraphM();
			}
		}
	}
	/*	show that we're done */
	updateBarGraphM();
	/*	We finished our job so return with noErr */
	AppDataPtr->BitsChanged = TRUE;
	/*	REMEMBER to kill the bar graph we put up */
	killBarGraphM();
	return(noErr);
}
